package util

import (
	"github.com/bwmarrin/discordgo"
)

func SendEmbed(dg *discordgo.Session, channelID string, embed *discordgo.MessageEmbed) {
	_, err := dg.ChannelMessageSendEmbed(channelID, embed)
	if err != nil {
		ReportError(dg, err)
	}
}

func SendSuccessEmbed(dg *discordgo.Session, channelID string, message string) {
	SendEmbed(dg, channelID, &discordgo.MessageEmbed{
		Title:       "Success",
		Description: message,
		Color:       0x00D000,
	})
}

func SendErrorEmbed(dg *discordgo.Session, channelID string, toSend error) {
	SendFailEmbed(dg, channelID, "Error", toSend.Error())
}

func SendFailEmbed(dg *discordgo.Session, channelID string, title string, description string) {
	SendEmbed(dg, channelID, &discordgo.MessageEmbed{
		Title:       title,
		Description: description,
		Color:       0xD00000,
	})
}
